/*****************************************************************/
/* 			smes.h                                   */
/* header file used by smes.c   				 */
/* Efren Mezura Montes         	   	 			 */
/* Last modification : 10/02/2005				 */
/*****************************************************************/
#define MAXBOUNDS 500
/*estructura que almacena la informacion del individuo */
typedef struct individuo{
	double *x;   /* decision varaibles*/
	double *f;    /* objective function */
	double *c;    /* constraints */
	double fitness; /* fitness */
	double sumviol; /* sum of constraint violation */
	int numviol;   /* number of violated constraints */
	int feasible; /* feasible (1) or infeasible (0)*/
	double *s;    /* sigma values */
	double *t;    /* angles (not used in SMES) */
	double normfitness; /* normalized fitness (not used in SMES) */
} tindividual;

typedef struct mejores{
	int posicion;	/* Position of the ordered solution */
	char pob;	/* population of the solution */
}tmejores;



/* function headers */
void warmup_random(float);
float randomperc();
void randomize();
int flip(float);
void advance_random();
void cls();
double Gauss(double sigma);
double N(double m, double sigma);
void initrandom(int seed);
double randreal(void);
int randint(int,int);
void memory_allocation();
void free_all();
void lee_archivo(char *);
float rndreal(float,float);
void initialize_pop();
void ordena(tindividual *,int,int *);
void obtiene_mejores();
void genera_nueva_poblacion();
void copia(tindividual *, tindividual *);
void nomemory(char *);
void imprime_ind(tindividual *);;
void imprime_pob(tindividual *,int );
void statistics(tindividual *,int);
void report();
void recombina(int);
double cruza_intermedia(double, double);
int selecti(int);
void mutacion(int);
void genera_nueva_poblacion_coma();
int calcula_mejorfx(tindividual *, int);
double calcula_desviacionmedia(tindividual *,int,double);
double calcula_varianza(tindividual *,int,double);
double calcula_media(tindividual *,int);
void actualiza_factibilidad(tindividual *,int);



void objfunc1(tindividual *);
void objfunc2(tindividual *);
void objfunc3(tindividual *);
void objfunc4(tindividual *);
void objfunc5(tindividual *);
void objfunc6(tindividual *);
void objfunc7(tindividual *);
void objfunc8(tindividual *);
void objfunc9(tindividual *);
void objfunc10(tindividual *);
void objfunc11(tindividual *);
void objfunc12(tindividual *);
void objfunc13(tindividual *);
void objfunc14(tindividual *);
void objfunc15(tindividual *);
void objfunc16(tindividual *);
void objfunc17(tindividual *);
void objfunc18(tindividual *);
void objfunc19(tindividual *);
void objfunc20(tindividual *);
void objfunc21(tindividual *);
void objfunc22(tindividual *);
void objfunc23(tindividual *);
void objfunc24(tindividual *);
/* ADD YOUR NEW FUNCTION HEADER 
   EXAMPLE:
void objfunc25(tindividual *); 
*/


float  Rseed;	    		   /* Random seed */
double oldrand[55];                /* 55 randiom numbers */
int jrand;                         /* current random number */
int t;				   /* current generation number */
int n;				   /* number of decision variables*/
int Gmax;			   /* number of generations */
double ps;			   /* Rate of successful mutations (not used) */
int nfunc;			   /* number of objective functions (usually 1)*/
int nrestric;			   /* number of constraints of the problem */
int nthetas;
tindividual *parents;		   /* parents population */
tindividual *childs;		   /* offspring population*/
tindividual *temporal;		   /* temporal population */
tindividual *externs;		   /* secondary population (not used) */
float semilla_a_reportar;          /* Initial random seed */
float bounds[2][MAXBOUNDS];    	   /* decision variable limits*/
int popsize1;
int popsize2;
double beta;
double tao,taoprima;
int datos_entrada;
double *sigma;
int *enordenparents,*enordenchilds;
tmejores *elite;
int filesize;
double sumfitness,facpercent,pftotal,min,max,avg;
int nofacxgen;
FILE *salida;
double EPSILON;
int filesize;
int flag;
double Sr;
double *epsilons;
int numepsilons;
double FACTE,Treduct;
int direccion;
