/****************************************************************************
        Archivo stats.c
Calcula las estadisticas  
Para compilar el programa solo teclee:   make s 
Para ejecutarlo teclee:                 ./stats

Regresa una tabla con los resultados.
Elaboro: Efren Mezura Montes
Materia: Trabajo de tesis doctoral 
Profesor:Dr Carlos A. Coello Coello
Fecha ultima modificacion: 10/06/2002
****************************************************************************/
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "stats.h"
#define NUMTEC 1 
#define PUNTOS 1000 
main(int argc, char *argv[]){
	unsigned cuantospuntos=PUNTOS;
	int i,j;
	char name[100];
	
	NUMRESTRIC=22;
	NUMVARS=20;
	memory_allocation(cuantospuntos);

/*	salida=fopen("table.tex","w");
	fprintf(salida,"\\begin{table}\n");
	fprintf(salida,"\\tiny\n");
	fprintf(salida,"\\begin{center}\n");
	fprintf(salida,"\\begin{tabular}{|c|c|c|c|c|c|c|}\n");
	fprintf(salida,"\\hline\n");
	fprintf(salida,"\\multicolumn{1}{|c|}{\\bf } &\n");
	fprintf(salida,"\\multicolumn{6}{|c|}{\\bf %s} \\\\ \n",techniques[0]);
	fprintf(salida,"\\cline{2-7}");
	fprintf(salida,"\\multicolumn{1}{|c|}{\\bf Problem} &\n");
	fprintf(salida,"\\multicolumn{1}{|c|}{\\bf Optimal} &\n");
	fprintf(salida,"\\multicolumn{1}{|c|}{\\bf Best} & \n ");
	fprintf(salida,"\\multicolumn{1}{|c|}{\\bf Mean} & \n");
	fprintf(salida,"\\multicolumn{1}{|c|}{\\bf Median} & \n ");
	fprintf(salida,"\\multicolumn{1}{|c|}{\\bf Worst} & \n");
	fprintf(salida,"\\multicolumn{1}{|c|}{\\bf St. Dev.} \\\\ \n");
	fprintf(salida,"\\hline \n");*/

	

	for(i=0;i<NUMTEC;i++){
		printf("--------------------------------------------------\n");
		printf("Tecnica %s \n",techniques[i]);
		for(j=0;j<NUMPROB;j++){
			strcpy(name,problems[j]);
			strcat(name,".dat");
//			puts(name);
//			exit(0);
			entrada1=fopen(name,"r");
			fscanf(entrada1,"%i\n",&n);
		        fscanf(entrada1,"%i\n",&nfunc);
		        fscanf(entrada1,"%i\n",&nrestric);
			fclose(entrada1);
			NUMVARS=n;
			NUMRESTRIC=nrestric;
			printf("Problem %s:\n",problems[j]);
			   
			lee_datos(techniques[i],problems[j]);	
			calcula_stats(techniques[i],problems[j],optimal[j]);
		}
	}
//	free_all(cuantospuntos);
/*	fprintf(salida,"\\end{tabular}\n");
	fprintf(salida,"\\end{center}\n");
	fprintf(salida,"\\normalsize\n");
	fprintf(salida,"\\caption{}\n"); 
	fprintf(salida,"\\label{table:}\n");
	fprintf(salida,"\\end{table}\n");
	fclose(salida);*/

}

void lee_datos(char *tec, char *problema){
	float fx,porfac,sumviol,res,x;
	int factible;
	int i,j,k;
	char cad[22];
	char cad1[100],cad2[100];

	strcpy(cad,"s");
	strcat(cad,problema);
//	strcat(cad,"bin");
	strcat(cad,tec);
	strcat(cad,".txt");

	puts(cad);
	entrada=fopen(cad,"r");
	i=0;
	while (!feof(entrada)){
		fscanf(entrada,"%f",&fx);
//		printf("RECIEN LEIDO VALE: %f\n",fx);
		if (fx != 10000000.000000 && fx != -99999996802856924650656260769173209088.000000){
			fscanf(entrada,"%d",&factible); 
			fscanf(entrada,"%f",&sumviol);
			soluciones[i].fx=fx;
			soluciones[i].factible=factible;
			soluciones[i].sumviol=sumviol;
			for (j=0; j< NUMRESTRIC; j++){
				fscanf(entrada,"%f",&res);
				soluciones[i].gs[j]=res;
			}
//			fscanf(entrada,"\n");
			for (k=0; k< NUMVARS; k++){
				fscanf(entrada,"%f",&x);
				soluciones[i].xs[k]=x;
			}
//			fscanf(entrada,"\n\n\n");
			fscanf(entrada,"%f\n",&porfac); 
			soluciones[i].porfac=porfac;
			i++;
		}
		else{
			fgets(cad1,160,entrada);
			fgets(cad1,160,entrada);
			fgets(cad1,160,entrada);
			fgets(cad1,160,entrada);
			fgets(cad1,160,entrada);
		}
	}
	fclose(entrada);
	if(i==0){
		i=1;
	}
	limitet=i;
	printf("Runs read: %d\t",limitet);
}

void calcula_stats(char *tec, char *problema,double optimal){

	int i,j,k,mitad;
	double  mediafx,desvfx,mediana;
	double minpf,maxpf,mediapf,desvpf;
	double mejor,peor;
	printf("Statistics for problem %s\t Technique %s\n",problema,tec);

	mediafx=calcula_media(0);
	mediapf=calcula_media(1);
	desvfx=calcula_desv(0,mediafx);
	desvpf=calcula_desv(1,mediapf);

	minpf=calcula_min();
	maxpf=calcula_max();

	ordena();
	mitad=limitet/2;
//	for(i=0;i<limitet;i++){
//		printf("f(x) %d: %f\n",i,soluciones[enorden[i]].fx);
//	}
	mediana=(soluciones[enorden[mitad]].fx+soluciones[enorden[mitad+1]].fx)/2.0;
	
	printf("f(x)  Mean= %f\t St. Dev.= %f\t Median= %f\n",mediafx,desvfx,mediana);
	printf("MAX  f(x) value \n");
	printf("f(x)= %f\t  feasible= %d\t sumviol= %f\n",soluciones[enorden[limitet-1]].fx,soluciones[enorden[limitet-1]].factible,soluciones[enorden[limitet-1]].sumviol);
	for (j=0; j< NUMRESTRIC; j++){
		printf("g%d(x)= %f\t",j+1,soluciones[enorden[limitet-1]].gs[j]);
	}
	printf("\n");
	for (k=0; k< NUMVARS; k++){
		printf("x%d= %f\t",k+1,soluciones[enorden[limitet-1]].xs[k]);
	}
	printf("\nMIN f(x) value \n");
	printf("f(x)= %f\t  feasible= %d\t sumviol= %f\n",soluciones[enorden[0]].fx,soluciones[enorden[0]].factible,soluciones[enorden[0]].sumviol);
	for (j=0; j< NUMRESTRIC; j++){
		printf("g%d(x)= %f\t",j+1,soluciones[enorden[0]].gs[j]);
	}
	printf("\n");
	for (k=0; k< NUMVARS; k++){
		printf("x%d= %f\t",k+1,soluciones[enorden[0]].xs[k]);
	}
	printf("\nMean rate of feasible solutions= %f\t St. Dev.= %f\t MAX= %f\t MIN= %f\n",mediapf,desvpf,maxpf,minpf);
	printf("-------------------------------------------------------\n");
	if(strcmp(problema,"g02")==0 || strcmp(problema,"g03")==0 || strcmp(problema,"g08")==0 || strcmp(problema,"g12")==0){
		mejor=soluciones[enorden[limitet-1]].fx;
		peor=soluciones[enorden[0]].fx;
	}
	else{
		mejor=soluciones[enorden[0]].fx;
		peor=soluciones[enorden[limitet-1]].fx;
	}
//	fprintf(salida,"%s & $%f$ & $%f$ & $%f$ & $%f$ & $%f$ & $%f$ \\\\\\hline  \n",problema,optimal,mejor,mediafx,mediana,peor,desvfx);
}


double calcula_desv(int deque, double media){
	double suma,desv;
	int i;

	suma=0.0;
	if(deque==0){
		for(i=0;i<limitet;i++){
			suma+=pow(soluciones[i].fx-media,2.0);
		}
		desv=sqrt(suma/limitet);
	}
	else{
		for(i=0;i<limitet;i++){
			suma+=pow(soluciones[i].porfac-media,2.0);
		}
		desv=sqrt(suma/limitet);
	}

	return(desv);
}

double calcula_max(){
	double max;
	int i;

	max=soluciones[0].porfac;
	for(i=1;i<limitet;i++){
		if(soluciones[i].porfac > max){
			max=soluciones[i].porfac;
		}
	}
	return(max);
}
	
double calcula_min(){
	double min;
	int i;

	min=soluciones[0].porfac;
	for(i=1;i<limitet;i++){
		if(soluciones[i].porfac < min){
			min=soluciones[i].porfac;
		}
	}
	return(min);
}
	


double calcula_media(int deque){
	double suma,media;
	int i;

	suma=0.0;

	if(deque==0){
		for(i=0;i<limitet;i++){
			suma+=soluciones[i].fx;
		}
	}
	else{
		for(i=0;i<limitet;i++){
			suma+=soluciones[i].porfac;
		}
	}

	media=suma/limitet;
	return(media);
}

void ordena(){
	int i,j,nointercambio,aux;

	for(i=0;i<limitet;i++){
		enorden[i]=i;
	}
	
	i=1;

	do{
		nointercambio=1;
		for(j=0;j<limitet-1;j++){
			if(soluciones[enorden[j]].fx > soluciones[enorden[j+1]].fx){
				aux=enorden[j];
				enorden[j]=enorden[j+1];
				enorden[j+1] = aux;
				nointercambio=0;
			}
		}
		i++;
	}while(nointercambio==0);
}




/* Aloja espacio para las cadenas que se generaran */
void memory_allocation(unsigned NPUNTOS)
{
	unsigned numbytes,aver1,aver2,aver3;
	char *malloc();
	int i;

        /* Aloja memoria  para las poblaciones */

	numbytes = NPUNTOS*2*sizeof(struct tsolucion);
	aver1 = NUMRESTRIC*sizeof(double);
	aver2 = NUMVARS*sizeof(double);
	aver3 = NPUNTOS*sizeof(int);
	if ((soluciones = (struct tsolucion *) malloc(numbytes)) == NULL)
		nomemory("soluciones");
	if ((enorden = (int *) malloc(aver3)) == NULL)
		nomemory("enorden");


       /* Aloja memoria para cada valor de cada funcion de cada individuo  */
	for (i=0; i< NPUNTOS; i++) {
		if ((soluciones[i].xs = (double *) malloc(aver2)) == NULL)
                        nomemory("arreglo de variables de cada solucion");
		if ((soluciones[i].gs = (double *) malloc(aver1)) == NULL)
                        nomemory("arreglo de restricciones de cada solucion");
	}
}
/* Limpia memoria */
void free_all(unsigned NPUNTOS)
{
	int i;

	for (i=0; i < NPUNTOS; i++) {
		free(soluciones[i].xs);
		free(soluciones[i].gs);
	}
	free(soluciones);
	free(enorden);
}
/* Envia mensaje de error si no hay memoria para otra cadena */

void nomemory(char *string)
{
	printf("ERROR!! --> malloc: out of memory making %s\n",string);
	exit(1);
}

